--[[
Author: Starinnia
Pitbull4_HolyPowerBar - Adds a simple bar display of Holy Power to Pitbull4
$Date: 2012-09-12 19:57:41 +0000 (Wed, 12 Sep 2012) $
$Revision: 14 $
Project Version: 1.0.5
contact: codemaster2010 AT gmail DOT com

Copyright (c) 2010-2012 Michael J. Murray aka Lyte of Lothar(US)
All rights reserved unless otherwise explicitly stated.
]]

if select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING" then return end

local PitBull4 = _G.PitBull4
if not PitBull4 then
	error("PitBull4_HolyPowerBar requires PitBull4")
end

if select(2, UnitClass("player")) ~= "PALADIN" then
	return
end

local EXAMPLE_VALUE = 2/3

local unpack = _G.unpack
local L = LibStub("AceLocale-3.0"):GetLocale("PitBull4_HolyPowerBar")

local PitBull4_HolyPowerBar = PitBull4:NewModule("HolyPowerBar", "AceEvent-3.0")

PitBull4_HolyPowerBar:SetModuleType("bar")
PitBull4_HolyPowerBar:SetName(L["Holy Power bar"])
PitBull4_HolyPowerBar:SetDescription(L["Show a bar indicating the unit's Holy Power count."])
PitBull4_HolyPowerBar:SetDefaults({
	position = 3
})

function PitBull4_HolyPowerBar:OnEnable()	
	self:RegisterEvent("UNIT_POWER")
	self:RegisterEvent("UNIT_DISPLAYPOWER")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
end

local function update_player(self)
	for frame in PitBull4:IterateFramesForUnitID("player") do
		if frame.HolyPowerBar then
			self:Update(frame)
		end
	end
end

function PitBull4_HolyPowerBar:UNIT_POWER(event, unit, kind)
	if unit ~= "player" or kind ~= "HOLY_POWER" then
		return
	end
	
	update_player(self)
end

function PitBull4_HolyPowerBar:UNIT_DISPLAYPOWER(event, unit)
	if unit ~= "player" then
		return
	end
	
	update_player(self)
end

function PitBull4_HolyPowerBar:PLAYER_ENTERING_WORLD(event)
	update_player(self)
end

local moduleUpdateFrame = PitBull4_HolyPowerBar.UpdateFrame
function PitBull4_HolyPowerBar:UpdateFrame(frame)
	if frame.unit ~= "player" then
		return self:ClearFrame(frame)
	end
	
	return moduleUpdateFrame(self, frame)
end

function PitBull4_HolyPowerBar:GetValue(frame)
	return UnitPower("player", SPELL_POWER_HOLY_POWER) / UnitPowerMax("player", SPELL_POWER_HOLY_POWER)
end

function PitBull4_HolyPowerBar:GetExampleValue(frame)
	return EXAMPLE_VALUE
end

function PitBull4_HolyPowerBar:GetColor(frame, value)
	return unpack(PitBull4.PowerColors.HOLY_POWER)
end

function PitBull4_HolyPowerBar:GetExampleColor(frame, value)
	return unpack(PitBull4.PowerColors.HOLY_POWER)
end
